// You have to turn on generating of detailed map file!

unit ULogExceptions;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Sockets, ExtCtrls, Registry, cTCPClient, WinSock;

const
  ErrorLogHost = 'www.zdechov.net';
  ErrorLogScript = 'jirihajda/error.php';
  NazevSouboru = 'Error.txt';

type
  TStoreError = class(TThread)
     Bezi: Boolean;
     procedure Execute; override;
  end;

  TRadekInfoVyjimky = record
    Popis: string;
    Text: string;
  end;

  TMapFile = class
  private
    FMapFileName: String;
    FSegmentData, FAdressData, FLineData: TStringList;
    FMapFileBase: DWORD;
    FExceptAddress: DWORD;
    FExceptLineNumber: Integer;
    FExceptMethodName: String;
    FExceptUnitName: String;
    FExceptionAnalyzed: Boolean;
    procedure SetMapFileName(const Value: String);
    procedure LoadMapFile;
  protected
  public
    constructor Create;
    destructor Destroy; override;

    procedure LoadExceptionData(Address: Pointer = nil);

    property MapFileName: String read FMapFileName write SetMapFileName;
    property MapFileBase: DWORD read FMapFileBase write FMapFileBase;
    property ExceptUnitName: String read FExceptUnitName;
    property ExceptMethodName: String read FExceptMethodName;
    property ExceptLineNumber: Integer read FExceptLineNumber;
    property ExceptAddress: DWORD read FExceptAddress;
    property ExceptionAnalyzed: Boolean read FExceptionAnalyzed;
  end;

  TLogExceptions = class(TForm)
    Label1: TLabel;
    Button1: TButton;
    Edit1: TEdit;
    Label2: TLabel;
    Button2: TButton;
    Memo1: TMemo;
    Image1: TImage;
    CheckBox1: TCheckBox;
    TcpClient1: TTcpClient;
    procedure Button2Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormDestroy(Sender: TObject);
  private
    FMapFile: TMapFile;
    Report: string;
    StoreError: TStoreError;
    Data: array of TRadekInfoVyjimky;
    Vyska: Integer;
    procedure Send;
  public
    Stav: string;            // Obsah loklnch promnnch
    NazevAplikace: string;   // Nzev aplikace
    AppReleaseDate: string;
    AppVersion: string;
    procedure Obsluha(Sender : TObject; E : Exception );
    procedure Pridat(NovyPopis, NovyText: string);
  end;

var
  LogExceptions: TLogExceptions;

implementation

{$R *.dfm}

{ TOsetreniVyjimek }

function ReturnAddr(Index: Integer): Pointer;
asm
  MOV     EAX,[EBP+Index*4]
end;

procedure TLogExceptions.Obsluha(Sender: TObject; E: Exception);
var
  ExtRec: PExceptionRecord;
  Log: string;
  Soubor: TextFile;
  I: Integer;
begin
  FMapFile.LoadExceptionData;
//  ShowMessage();
  Pridat('as', DateTimeToStr(Now));
  Pridat('Aplikace', NazevAplikace);
  Pridat('Verze', AppVersion);
  Pridat('Datum vydn', AppReleaseDate);
  Pridat('Text chyby', E.Message);
  Pridat('Tda vyjmky', E.ClassName);
  Pridat('Adresa', Format('%p',[ReturnAddr(6)]));
  Pridat('Jednotka', FMapFile.ExceptUnitName);
  Pridat('Metoda', FMapFile.ExceptMethodName);
  Pridat('dek', IntToStr(FMapFile.ExceptLineNumber));
  Pridat('Stavov informace', Stav);

  ShowModal;    // Uka dialog

  if Edit1.Text<>'' then Pridat('Koment uivatele',Edit1.Text);

  // Uloit chybu do souboru
  AssignFile(Soubor,NazevSouboru);
  try
    if FileExists(NazevSouboru) then Append(Soubor) else Rewrite(Soubor);
    WriteLn(Soubor);
    for I := 0 to High(Data) do WriteLn(Soubor,Data[I].Popis+': '+Data[I].Text);
  finally
    CloseFile(Soubor);
  end;
  StoreError.Execute;
end;

procedure TLogExceptions.Pridat(NovyPopis, NovyText: string);
begin
  SetLength(Data,Length(Data)+1);
  with Data[High(Data)] do begin
    Popis := NovyPopis;
    Text := NovyText;
  end;
end;

procedure TLogExceptions.Send;
var
  I, II: Integer;
  Hlaseni: string;
  Buf: array[0..10000] of Char;
  Pocet: Integer;
  Radek: string;
  UseProxy: Boolean;
  ProxyServer: string;
  ProxyPort: string;
  Host, HostHTTP: string;
begin
  // Check if proxy server enabled
  with TRegistry.Create do try
    RootKey := HKEY_CURRENT_USER;
    OpenKey('\SOFTWARE\Microsoft\Windows\CurrentVersion\Internet Settings', False);
    UseProxy := ReadBool('ProxyEnable');
    ProxyServer := ReadString('ProxyServer');
  finally
    Free;
  end;

  // Generate report
  Hlaseni := '';
  for I := 0 to High(Data) do with Data[I] do
    Hlaseni := Hlaseni + '&' + Popis + '=' + Text;
  Delete(Hlaseni, 1, 1);

  // Replace blank spaces by special char %20
  while Pos(' ', Hlaseni) > 0 do
    Hlaseni := Copy(Hlaseni, 1, Pos(' ', Hlaseni)-1) + '%20' + Copy(Hlaseni, Pos(' ', Hlaseni) + 1, Length(Hlaseni));

  if UseProxy then begin
    ProxyPort := Copy(ProxyServer,Pos(':',ProxyServer)+1,255);
    Delete(ProxyServer,Pos(':',ProxyServer),255);
    TcpClient1.RemoteHost := ProxyServer;
    TcpClient1.RemotePort := ProxyPort;
  end else begin
    TcpClient1.RemoteHost := ErrorLogHost;
    TcpClient1.RemotePort := '80';
  end;

  HostHTTP := 'http://' + ErrorLogHost + '/' + ErrorLogScript;
  with TcpClient1 do begin
    Connect;
    if Connected then begin
      SendLn('GET ' + HostHTTP + '?' + Hlaseni + ' HTTP/1.0');
      SendLn('Accept: text/html');
      SendLn('Content-Type: text/plain; charset="iso-8859-2"');
      SendLn('Content-length: '+IntToStr(Length(Hlaseni)));
      Hlaseni := '';
      if UseProxy then SendLn('Host: ' + ErrorLogHost);
      SendLn('');
      SendLn(Hlaseni);
//      Memo1.Lines.Add(Hlaseni);

      //for I := 0 to 100 do
      //  Memo1.Lines.Add(Receiveln);
      Close;

    end; // else ShowMessage('Nepodailo se pipojit k serveru');
  end;
  SetLength(Data,0);
end;

procedure TLogExceptions.Button2Click(Sender: TObject);
begin
  if Height = Vyska then Height := Vyska + Memo1.Height + 8 else Height := Vyska;
end;

procedure TLogExceptions.FormShow(Sender: TObject);
var
  I: Integer;
begin
  Vyska := Height;
  Memo1.Clear;
  for I := 0 to High(Data) do with Data[I] do Memo1.Lines.Add(Popis+': '+Text);
  Edit1.Text := '';
  Send;
end;

procedure TLogExceptions.Button1Click(Sender: TObject);
begin
  if CheckBox1.Checked then Application.Terminate;
  Close;
end;

{ TOdeslani }

procedure TStoreError.Execute;
begin
  Bezi := True;
  LogExceptions.Send;
  Bezi := False;
end;

procedure TLogExceptions.FormCreate(Sender: TObject);
begin
  StoreError := TStoreError.Create(True);
  NazevAplikace := Application.Title;
  Application.OnException := Obsluha;
  FMapFile := TMapFile.Create;
  FMapFile.MapFileName := ChangeFileExt(Application.ExeName, '.map');
end;

procedure TLogExceptions.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  Height := Vyska;
end;

procedure TLogExceptions.FormDestroy(Sender: TObject);
begin
  FreeAndNil(FMapFile);
end;

{ TMapFile }

constructor TMapFile.Create;
begin
  inherited Create;
  FSegmentData := TStringList.Create;
  FAdressData := TStringList.Create;
  FLineData := TStringList.Create;
  FMapFileName := '';
  FMapFileBase := $00401000;
  FExceptAddress := 0;
  FExceptLineNumber := 0;
  FExceptMethodName := '';
  FExceptUnitName := '';
  FExceptionAnalyzed := False;
end;

destructor TMapFile.Destroy;
begin
  FreeAndNil(FSegmentData);
  FreeAndNil(FAdressData);
  FreeAndNil(FLineData);
  inherited Destroy;
end;

procedure TMapFile.LoadExceptionData(Address: Pointer);
var
  UnitLineDataFound: Boolean;
  I, J, LastLine: Integer;
  Start, Stop, ProcAddr, LineAddr: DWORD;
  Line: String;
begin
  // reset
  FExceptAddress := 0;
  FExceptLineNumber := 0;
  FExceptMethodName := '';
  FExceptUnitName := '';
  FExceptionAnalyzed := False;

  // load address
  if Address = nil then
    Address := ExceptAddr;
  if Address = nil then
    Exit;

  // load and adjust exception address
  FExceptAddress := DWORD(Address) - FMapFileBase;

  // find unit of exception
  I := 0;
  while (I < FSegmentData.Count) and (FSegmentData[I] <> '') do
  begin
    try
      // check whether address is within unit address limits
      Start := DWORD(StrToInt('0x' + Copy(FSegmentData[I], 7, 8)));
      Stop := Start + DWORD(StrToInt('0x' + Copy(FSegmentData[I], 16, 8)));
      if (Start <= FExceptAddress) and (FExceptAddress < Stop) then
      begin
        Start := Pos('M=', FSegmentData[I]) + 2;
        Stop := Pos('ACBP=', FSegmentData[I]);
        if (Start > 0) and (Stop > 0) then
          FExceptUnitName :=
            Trim(Copy(FSegmentData[I], Start, Stop - Start - 1));
      end;
    except
    end;
    Inc(I);
  end;

  // find function of exception
  I := 0;
  while I < FAdressData.Count do
  begin
    try
      ProcAddr := DWORD(StrToInt('0x' + Copy(FAdressData[I], 7, 8)));
      if ProcAddr >= FExceptAddress then
      begin
        if ProcAddr = FExceptAddress then
          Line := FAdressData[I]
        else
          Line := FAdressData[Pred(I)];
        FExceptMethodName := Trim(Copy(Line, 22, Length(Line)));
        Break;
      end;
    except
    end;
    Inc(I);
  end;

  // find line number of exception
  I := 0;
  UnitLineDataFound := False;
  // search for unit section
  while I < FLineData.Count do
  begin
    if Pos(FExceptUnitName, FLineData[I]) <> 0 then
    begin
      UnitLineDataFound := True;
      Break;
    end;
    Inc(I);
  end;
  if UnitLineDataFound then
  begin
    // search for line number
    LastLine := 0;
    LineAddr := 0;
    Inc(I, 2);
    while I < FLineData.Count do
    begin
      //ShowMessage(FLineData[I]);
      if Pos('Line numbers for', FLineData[I]) <> 0 then
        Break;
      if FLineData[I] <> '' then 
      try
        for J := 0 to 3 do
        begin
          LineAddr := StrToInt('0x' + Copy(FLineData[I], J * 20 + 13, 8));
          if LineAddr > FExceptAddress then
            Break;
          LastLine := StrToInt(Trim(Copy(FLineData[I], J * 20 + 1, 6)));
          if LineAddr = FExceptAddress then
            Break;
        end;
      except
      end;
      Inc(I);
    end;
    if LineAddr >= FExceptAddress then
      FExceptLineNumber := LastLine;
  end;

  FExceptionAnalyzed := True;
end;

procedure TMapFile.LoadMapFile;
var
  I: Integer;
begin
  FSegmentData.Clear;
  FAdressData.Clear;
  FLineData.Clear;
  if FileExists(FMapFileName) then
    with TStringList.Create do
    try
      LoadFromFile(FMapFileName);
      // find start of detailed segment block
      I := 0;
      while I < Count do
        if Pos('Detailed map of segments', Strings[I]) <> 0 then
          Break
        else
          Inc(I);
      Inc(I, 2);

      // copy all lines to segment data, until name-address block starts
      while I < Count do
        if Pos('Address         Publics by Name', Strings[I]) <> 0 then
          Break
        else begin
          FSegmentData.Add(Strings[I]);
          Inc(I);
        end;

      // find start of value-address block
      while I < Count do
        if Pos('Address         Publics by Value', Strings[I]) <> 0 then
          Break
        else
          Inc(I);
      Inc(I, 3);

      // copy all lines to address data, until line number block starts
      while I < Count do
        if Pos('Line numbers for', Strings[I]) <> 0 then
          Break
        else begin
          FAdressData.Add(Strings[I]);
          Inc(I);
        end;

      // copy all remaining lines to line data
      while I < Count do
      begin
        FLineData.Add(Strings[I]);
        Inc(I);
      end;
    finally
      Free;
    end;
end;

procedure TMapFile.SetMapFileName(const Value: String);
begin
  if FMapFileName <> Value then
  begin
    FMapFileName := Value;
    LoadMapFile;
  end;
end;

end.
